 
//Copyright (C) 2004-2013 MKTMK Moscow, Russia
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//v.1.01 12.02.2001(last modification 22.04.2012)
//Vector

#ifndef MVECT_THIS
#define MVECT_THIS

#ifndef MVECT_NULL
#define MVECT_NULL (0)
#endif

#ifndef MVECT_INLINE
#define MVECT_INLINE inline
#endif

#include <mstore.h>

template <class typebase>
class mvect_common:public typebase{
public:

typedef typename typebase::tstore typestore;
typedef typename typebase::tcount typecount;

mvect_common(){}
mvect_common(typecount s):typebase(s){}
mvect_common(typestore* data1,typecount s):typebase(data1,s){}

mvect_common(typestore* data1,typestore end,typecount max):
typebase(data1,end,max){}

typestore& operator[](typecount i){return typebase::data[i];}

//operator typestore*() {return c_str();}
typestore* c_str(){return typebase::data;}

template <class F>
bool find(F* f,
typecount startcount,
typecount endcount,
typecount* current);

template <class typebase1>
mvect_common& operator =(const mvect_common<typebase1>& d){
*((typebase*)this)=*((typebase1*)&d);
}

mvect_common& operator =(const mvect_common& d){
*((typebase*)this)=*((typebase*)&d);
return *this;
}

mvect_common(const mvect_common<typebase>& d):typebase(*((typebase*)&d)){
}

template <class typebase1>
mvect_common(const mvect_common<typebase1>& d):typebase(*((typebase1*)&d)){
}

template <class typebase1>
bool operator ==(const mvect_common<typebase1>& d) const;

template <class typebase1>
bool operator <(const mvect_common<typebase1>& d) const;

template <class typebase1>
bool operator >(const mvect_common<typebase1>& d) const;

template <class typebase1>
bool operator <=(const mvect_common<typebase1>& d) const {return !(operator >(d));}

template <class typebase1>
bool operator >=(const mvect_common<typebase1>& d) const {return !(operator <(d));}

template <class typebase1>
bool operator !=(const mvect_common<typebase1>& d) const {return !(operator ==(d));}

bool
compareless(const typestore* data,const typestore* data1,typecount count,typecount count1) const;

bool
comparegreat(const typestore* data,const typestore* data1,typecount count,typecount count1) const;

template <class typebase1>
bool compareless(const mvect_common<typebase1>* d) const;

template <class typebase1>
bool comparegreat(const mvect_common<typebase1>* d) const;
};

template <class typebase>
template <class typebase1>
MVECT_INLINE
bool mvect_common<typebase>::operator ==(const mvect_common<typebase1>& d) const {

typecount l=typebase::getcount();
if(l==d.getcount()){

typecount i;

  for(i=typecount();i!=l;++i){
    if(typebase::data[i]!=d.getdata()[i]){
    return false;
    }//if
  }//for
return true;
}//if

else{
return false;
}//else
}

template <class typebase>
bool
mvect_common<typebase>::
compareless(const typestore* data,const typestore* data1,typecount count,typecount count1) const {

if(count>count1) return false;
if(count==typecount()) return false;

typecount i;

  for(i=typecount();i!=count;++i){
    if(data[i]>=data1[i]){
    return false;
    }//if
  }//for

return true;
}

template <class typebase>
bool
mvect_common<typebase>::
comparegreat(const typestore* data,const typestore* data1,typecount count,typecount count1) const {

if(count<count1) return false;
if(count1==typecount()) return false;

typecount i;

  for(i=typecount();i!=count1;++i){
    if(data[i]<=data1[i]){
    return false;
    }//if
  }//for

return true;
}

//compare for string
template <class typebase>
template <class typebase1>
MVECT_INLINE
bool mvect_common<typebase>::operator <(const mvect_common<typebase1>& d) const {
return 
compareless(
typebase::getdata(),d.getdata(),typebase::getcount()-1,d.getcount()-1);
}

template <class typebase>
template <class typebase1>
MVECT_INLINE
bool mvect_common<typebase>::operator >(const mvect_common<typebase1>& d) const {
return 
comparegreat(
typebase::getdata(),d.getdata(),typebase::getcount()-1,d.getcount()-1);
}

//compare for full vector
template <class typebase>
template <class typebase1>
MVECT_INLINE
bool mvect_common<typebase>::compareless(const mvect_common<typebase1>* d) const {
return compareless(this->getdata(),d->getdata(),this->getcount(),d->getcount());
}

template <class typebase>
template <class typebase1>
MVECT_INLINE
bool mvect_common<typebase>::comparegreat(const mvect_common<typebase1>* d) const {
return comparegreat(this->getdata(),d->getdata(),this->getcount(),d->getcount());
}

template <class typebase>
template <class F>
MVECT_INLINE
bool mvect_common<typebase>::
find(F* f,
typecount startcount,
typecount endcount,
typecount* current){

typecount i;

typecount start=startcount;
typecount end=endcount;

if(start>end) {i=start;start=end;end=i;}
if(end>=typebase::getcount()) {end=typebase::getcount();--end;}

++end;

for(i=start;i!=end;++i){
  if((*f)((typebase::getdata())[i])==true){
  current=i;
  return true;
  }//if
}//for
return false;
}

#endif

